

#ifndef APP_H_
#define APP_H_

/* bit operation */
#define SETBIT(x,y) (x |= _BV(y))
#define CLRBIT(x,y) (x &=~ _BV(y))
#define CHKBIT(x,y) (x & _BV(y))
#define INVBIT(x,y) (x ^= _BV(y))

/* 基本定时时间(毫秒) */
#define TIME_MS  100
#define OCR_VALUE 	(TIME_MS * (F_CPU / 1000000UL) / (1024 / 1000.0f))

/* 连接等待 */
//#define WAIT_C_CNT 	(TIME_WAIT_C * 1000 / TIME_MS)
#define WAIT_C_CNT 	(TIME_WAIT_C * 10)

/* 数据等待 */
//#define WAIT_D_CNT 	(TIME_WAIT_D * 1000 / TIME_MS)
#define WAIT_D_CNT 	(TIME_WAIT_D * 10)

#if U2X_
#define	UBRR_VALUE (uint16_t)(F_CPU / (8UL * BUADRATE) - 1)
#else
#define UBRR_VALUE (uint16_t)(F_CPU / (16UL * BUADRATE) - 1)
#endif

#define UBRRH_VALUE (UBRR_VALUE / 256)
#define UBRRL_VALUE (UBRR_VALUE % 256)

#define CHECK_RXC CHKBIT(UCSRA, RXC)

#define GLUE(a,b)  (a##b)
#define PORT(x) GLUE(PORT,x)
#define DDR(x)  GLUE(DDR,x)
#define PIN(x)  GLUE(PIN,x)

#define SET_LED_PORT_OUT SETBIT(DDR(LED_PORT), LED_PIN)
#define LED_ACT		INVBIT(PORT(LED_PORT), LED_PIN)

#define SET_TRI_PORT_IN CLRBIT(DDR(TRI_PORT), TRI_PIN);SETBIT(PORT(TRI_PORT), TRI_PIN)
#define CHECK_TRI_PIN 	CHKBIT(PIN(TRI_PORT), TRI_PIN)	


/* XMODEM控制字 */
#define XMODEM_NUL 0x00
#define XMODEM_SOH 0x01
#define XMODEM_STX 0x02
#define XMODEM_EOT 0x04
#define XMODEM_ACK 0x06
#define XMODEM_NAK 0x15
#define XMODEM_CAN 0x18
#define XMODEM_EOF 0x1a
#define XMODEM_RWC 'C'


extern void device_init(void);
extern void timer_init(void);
extern void usart_init(void);
extern void write_udr(uint8_t c);
extern uint8_t read_udr(void);
extern void put_string(char *str);
extern void quit(void);
extern void boot_program_page(uint32_t page, uint8_t *buf);

#endif
